import { world, Player, system } from "@minecraft/server";
import { ActionFormData, ActionFormResponse, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(data => {
    let player = data.source
    if (data.itemStack.typeId == "fiery:skillbook_double_jump")
        system.run(() => primaryMenu(player))

    function primaryMenu(player) {
        new ActionFormData()
            .title("custom_form_Page 1")
            .button("")
            .button("next_button")
            .button("I - 10 EXP", "textures/ui/double_jump0")
            .button("II - 20 EXP", "textures/ui/double_jump1")
            .show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 1) {
                    secondMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('DoubleJump0') && player.level >= 10) {
                        player.addTag('DoubleJump0');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bDouble Jump I");
                        player.addLevels(-10);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('DoubleJump0') && !player.hasTag('DoubleJump3') && player.level <= 10) {
                        player.sendMessage("§cRequired §a10 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('DoubleJump0') && !player.hasTag('DoubleJump3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('DoubleJump1') && player.hasTag('DoubleJump0') && player.level >= 20) {
                        player.addTag('DoubleJump1');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bDouble Jump II");
                        player.addLevels(-20);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('DoubleJump0')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('DoubleJump1') && player.level <= 20) {
                        player.sendMessage("§cRequired §a20 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('DoubleJump1')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
            });
    }

    function secondMenu(player) {
        new ActionFormData()
            .title("custom_form_Page 2")
            .button("prev_button")
            .button("next_button")
            .button("III - 30 EXP", "textures/ui/double_jump2")
            .button("IV - 40 EXP", "textures/ui/double_jump3")
            .show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 0) {
                    primaryMenu(player);
                }
                if (form.selection === 1) {
                    treeMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('DoubleJump2') && player.hasTag('DoubleJump1') && player.level >= 30) {
                        player.addTag('DoubleJump2');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bDouble Jump III");
                        player.addLevels(-30);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('DoubleJump1')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('DoubleJump2') && player.level <= 30) {
                        player.sendMessage("§cRequired §a30 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('DoubleJump2')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('DoubleJump3') && player.hasTag('DoubleJump2') && player.level >= 40) {
                        player.addTag('DoubleJump3');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bDouble Jump IV");
                        player.addLevels(-40);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('DoubleJump2')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('DoubleJump3') && player.level <= 40) {
                        player.sendMessage("§cRequired §a40 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('DoubleJump3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
            });
    }
    function treeMenu(player) {
        const DoubleJumpUi = new ActionFormData()
            .title("custom_form_Page 3")
            .button("prev_button")
            .button("")
            .button("V - 50 EXP", "textures/ui/double_jump4")
        if (player.hasTag("DisableDoubleJump")) {
            DoubleJumpUi.button("Enable Double Jump", "textures/ui/confirm")
        }
        if (!player.hasTag("DisableDoubleJump")) {
            DoubleJumpUi.button("Disable Double Jump", "textures/ui/cancel")
        }
        DoubleJumpUi.show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 0) {
                    secondMenu(player);
                }
                if (form.selection === 1) {
                    fourMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('DoubleJump4') && player.hasTag('DoubleJump3') && player.level >= 50) {
                        player.addTag('DoubleJump4');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§mDouble Jump V");
                        player.addLevels(-50);
                        player.playSound("random.levelup");
                    } else if (!player.hasTag('DoubleJump3')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    } else if (!player.hasTag('DoubleJump4') && player.hasTag('DoubleJump1') && player.hasTag('DoubleJump2') && player.hasTag('DoubleJump3') && player.level <= 50) {
                        player.sendMessage("§cRequired §a50 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('DoubleJump4') && player.hasTag('DoubleJump1') && player.hasTag('DoubleJump2') && player.hasTag('DoubleJump3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('DisableDoubleJump')) {
                        player.addTag('DisableDoubleJump');
                        player.playSound("random.break");
                    } else {
                        player.removeTag('DisableDoubleJump');
                        player.playSound("random.orb");
                    }
                }
            });
    }
});

world.beforeEvents.itemUse.subscribe(data => {
    let player = data.source
    if (data.itemStack.typeId == "fiery:skillbook_air_dash")
        system.run(() => primaryMenu(player))

    function primaryMenu(player) {
        new ActionFormData()
            .title("custom_form_Page 1")
            .button("")
            .button("next_button")
            .button("I - 10 EXP", "textures/ui/air_dash0")
            .button("II - 20 EXP", "textures/ui/air_dash1")
            .show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 1) {
                    secondMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('AirDash0') && player.level >= 10) {
                        player.addTag('AirDash0');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bAir Dash I");
                        player.addLevels(-10);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('AirDash0') && !player.hasTag('AirDash3') && player.level <= 10) {
                        player.sendMessage("§cRequired §a10 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('AirDash0') && !player.hasTag('AirDash3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('AirDash1') && player.hasTag('AirDash0') && player.level >= 20) {
                        player.addTag('AirDash1');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bAir Dash II");
                        player.addLevels(-20);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('AirDash0')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('AirDash1') && player.level <= 20) {
                        player.sendMessage("§cRequired §a20 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('AirDash1')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
            });
    }

    function secondMenu(player) {
        new ActionFormData()
            .title("custom_form_Page 2")
            .button("prev_button")
            .button("next_button")
            .button("III - 30 EXP", "textures/ui/air_dash2")
            .button("IV - 40 EXP", "textures/ui/air_dash3")
            .show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 0) {
                    primaryMenu(player);
                }
                if (form.selection === 1) {
                    treeMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('AirDash2') && player.hasTag('AirDash1') && player.level >= 30) {
                        player.addTag('AirDash2');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bAir Dash III");
                        player.addLevels(-30);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('AirDash1')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('AirDash2') && player.level <= 30) {
                        player.sendMessage("§cRequired §a30 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('AirDash2')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('AirDash3') && player.hasTag('AirDash2') && player.level >= 40) {
                        player.addTag('AirDash3');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§bAir Dash IV");
                        player.addLevels(-40);
                        player.playSound("random.levelup");
                        //durability.damage += 1;
                        inventory.setItem(player.selectedSlot, selectedItem);
                    } else if (!player.hasTag('AirDash2')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    }
                    else if (!player.hasTag('AirDash3') && player.level <= 40) {
                        player.sendMessage("§cRequired §a40 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('AirDash3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
            });
    }
    function treeMenu(player) {
        const AirDashUi = new ActionFormData()
            .title("custom_form_Page 3")
            .button("prev_button")
            .button("")
            .button("V - 50 EXP", "textures/ui/air_dash4")
        if (player.hasTag("DisableAirDash")) {
            AirDashUi.button("Enable Air Dash", "textures/ui/confirm")
        }
        if (!player.hasTag("DisableAirDash")) {
            AirDashUi.button("Disable Air Dash", "textures/ui/cancel")
        }
        AirDashUi.show(player)
            .then((form) => {
                if (form.canceled) return;
                if (form.selection === 0) {
                    secondMenu(player);
                }
                if (form.selection === 1) {
                    fourMenu(player);
                }
                if (form.selection == 2) {
                    if (!player.hasTag('AirDash4') && player.hasTag('AirDash3') && player.level >= 50) {
                        player.addTag('AirDash4');
                        player.sendMessage("§aCongratulations! You have unlocked the ability §l§mAir Dash V");
                        player.addLevels(-50);
                        player.playSound("random.levelup");
                    } else if (!player.hasTag('AirDash3')) {
                        player.sendMessage("§cYou need to unlock the previous ability first!");
                        player.playSound("random.break");
                    } else if (!player.hasTag('AirDash4') && player.hasTag('AirDash1') && player.hasTag('AirDash2') && player.hasTag('AirDash3') && player.level <= 50) {
                        player.sendMessage("§cRequired §a50 experiences§c to unlock this ability!");
                        player.playSound("random.break");
                    } else if (player.hasTag('AirDash4') && player.hasTag('AirDash1') && player.hasTag('AirDash2') && player.hasTag('AirDash3')) {
                        player.sendMessage("§aYou already unlocked this ability!");
                        player.playSound("random.orb");
                    }
                }
                if (form.selection == 3) {
                    if (!player.hasTag('DisableAirDash')) {
                        player.addTag('DisableAirDash');
                        player.playSound("random.break");
                    } else {
                        player.removeTag('DisableAirDash');
                        player.playSound("random.orb");
                    }
                }
            });
    }
});