import "./double_jump.js";
import "./air_dash.js";
import "./form.js";
//import "./guard.js";

import { system, world } from "@minecraft/server";

const lore_item = {
    "fiery:skillbook_double_jump": ["§r§7Ability:\n §9Double Jump"],
    "fiery:skillbook_air_dash": ["§r§7Ability:\n §9Air Dash"]
};

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const inventory = player.getComponent("inventory").container;
        for (let i = 0; i < 36; i++) {
            const slot = inventory.getSlot(i);
            if (!slot.getItem() || !lore_item[slot.typeId] || slot.getLore().length)
                continue;

            slot.setLore(lore_item[slot.typeId]);
        }
    }
}, 10);

system.runInterval(() => world.getAllPlayers().forEach(player => {
    if (player.hasTag("cd_jump_v") || player.hasTag("cd_air_dash_v")) {
        player.dimension.spawnParticle('fiery:small_black_smoke', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        })
    }
}), 3);